Package org.eclipse.swt.layout

# Class BorderLayout

java.lang.Object
org.eclipse.swt.widgets.Layout
org.eclipse.swt.layout.BorderLayout

public class BorderLayout extends Layout
`BorderLayout` places controls in five regions

     +--------------------------------+
     |       NORTH / TOP              |
     +---+------------------------+---+
     |   |                        |   |
     | W |                        | E |
     | E |                        | A |
     | S |                        | S |
     | T |                        | T |
     | / |                        | / |
     | L |       CENTER           | R |
     | E |                        | I |
     | F |                        | G |
     | T |                        | H |
     |   |                        | T |
     |   |                        |   |
     +---+------------------------+---+
     |       SOUTH / BOTTOM           |
     +--------------------------------+

The controls at the NORTH/SOUTH borders get their preferred heights, the controls at the EAST/WEST get their preferred widths and the center region grow/shrink according to the remaining space. If more than one control is placed inside a region the controls are equally distributed across their axis where the grow (CENTER controlled by the `type` value)

Since:
  3.119

## Field Summary

Fields
Modifier and Type
Field
Description
`int`
`controlSpacing`
controlSpacing specifies the number of points between the edge of one control and its neighboring control inside a region.
`double`
`heightDistributionFactor`
If the height of the `SWT.TOP` and `SWT.BOTTOM` region exceeds the available space this factor is used to distribute the size to the controls, valid values range between [0 ... 1] The default value is 0.5 (equal distribution of available space)
`int`
`marginHeight`
marginHeight specifies the number of points of vertical margin that will be placed along the top and bottom edges of the layout.
`int`
`marginWidth`
marginWidth specifies the number of points of horizontal margin that will be placed along the left and right edges of the layout.
`int`
`spacing`
spacing specifies the number of points between the edge of one region and its neighboring regions.
`int`
`type`
type specifies how controls will be positioned within the center region.
`double`
`widthDistributionFactor`
If the width of the `SWT.LEFT` and `SWT.RIGHT` region exceeds the available space this factor is used to distribute the size to the controls, valid values range between [0 ... 1] The default value is 0.5 (equal distribution of available space)

## Constructor Summary

Constructors
Constructor
Description
`BorderLayout()`

## Method Summary

Modifier and Type
Method
Description
`protected Point`
`computeSize(Composite composite, int wHint, int hHint, boolean flushCache)`
Computes and returns the size of the specified composite's client area according to this layout.
`protected void`
`layout(Composite composite, boolean flushCache)`
Lays out the children of the specified composite according to this layout.
`String`
`toString()`

### Methods inherited from class org.eclipse.swt.widgets.Layout

`flushCache`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Field Details

### type

public int type
type specifies how controls will be positioned within the center region. The default value is `SWT.HORIZONTAL`. Possible values are:

- `SWT.HORIZONTAL`: Position the controls horizontally from left to right
- `SWT.VERTICAL`: Position the controls vertically from top to bottom

### marginWidth

public int marginWidth
marginWidth specifies the number of points of horizontal margin that will be placed along the left and right edges of the layout. The default value is 0.

### marginHeight

public int marginHeight
marginHeight specifies the number of points of vertical margin that will be placed along the top and bottom edges of the layout. The default value is 0.

### spacing

public int spacing
spacing specifies the number of points between the edge of one region and its neighboring regions. The default value is 0.

### controlSpacing

public int controlSpacing
controlSpacing specifies the number of points between the edge of one control and its neighboring control inside a region. The default value is 0.

### widthDistributionFactor

public double widthDistributionFactor
If the width of the `SWT.LEFT` and `SWT.RIGHT` region exceeds the available space this factor is used to distribute the size to the controls, valid values range between [0 ... 1] The default value is 0.5 (equal distribution of available space)

### heightDistributionFactor

public double heightDistributionFactor
If the height of the `SWT.TOP` and `SWT.BOTTOM` region exceeds the available space this factor is used to distribute the size to the controls, valid values range between [0 ... 1] The default value is 0.5 (equal distribution of available space)

## Constructor Details

### BorderLayout

public BorderLayout()

## Method Details

### computeSize

protected Point computeSize(Composite composite, int wHint, int hHint, boolean flushCache)
Description copied from class: `Layout`
Computes and returns the size of the specified composite's client area according to this layout.

This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

Specified by:
  `computeSize` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `wHint` - width (`SWT.DEFAULT` for preferred size)
  `hHint` - height (`SWT.DEFAULT` for preferred size)
  `flushCache` - `true` means flush cached layout values
Returns:
  a point containing the computed size (width, height)
See Also:
  - `Layout.layout(org.eclipse.swt.widgets.Composite, boolean)`
  - `Control.getBorderWidth()`
  - `Control.getBounds()`
  - `Control.getSize()`
  - `Control.pack(boolean)`
  - "computeTrim, getClientArea for controls that implement them"

### layout

protected void layout(Composite composite, boolean flushCache)
Description copied from class: `Layout`
Lays out the children of the specified composite according to this layout.

This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

Specified by:
  `layout` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `flushCache` - `true` means flush cached layout values

### toString

public String toString()

Overrides:
  `toString` in class `Object`